﻿Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Data.OleDb
Public Class TestPrintClass
    Dim WithEvents PrintDocument1 As New System.Drawing.Printing.PrintDocument
    Public Enum TitleType As Integer
        StandardGridTitle = 1
        OneBoxTitle = 2
    End Enum
    Public Enum AlignStyle As Integer
        TopLeft = 1
        TopCenter = 2
        TopRight = 3
        Middleleft = 4
        MiddleCenter = 5
        MiddleRight = 6
        BottomLeft = 7
        BottomCenter = 8
        BottomRight = 9
    End Enum
    Dim LineCounter As Integer
    Dim TitlePrinted As Boolean
    Dim LinesPerPage As Integer
    Dim MaxPage As Integer = 9999
    Private MyRtb As RichTextBox

    Public WriteOnly Property SetRtf As RichTextBox
        Set(value As RichTextBox)
            MyRtb = value
        End Set
    End Property

#Region "Page variables"
    Dim MyPage As System.Drawing.Graphics
    Dim MaxHeight As Integer
    Dim MaxWidth As Integer
    Dim sf As New StringFormat
    Dim ThisString As String
    Dim MaxPageWidth As Integer
    Dim MaxPageHeight As Integer
    Dim StartPage As Integer = 0
    Dim pageCounter As Integer = 0
    Dim myWidth As Integer
    Dim startX As Integer = 50
    Dim startY As Integer = 0
    Dim Rect As Rectangle
    Dim LineSpace As Integer
    ' Dim LinesPerPage As Integer
    Dim MyFont As Font
    Dim H0Font As New Font("Calibri", 10, FontStyle.Bold)
    Dim H1Font As New Font("Calibri", 10, FontStyle.Bold Or FontStyle.Underline)
    Dim H2Font As New Font("Calibri", 12, FontStyle.Bold)
#End Region

    Private Sub PrintDocument1_PrintPage(sender As Object, e As PrintPageEventArgs) Handles PrintDocument1.PrintPage
        pageCounter += 1
        If pageCounter > MaxPage Then
            e.HasMorePages = False
            InitDocument()
            Exit Sub
        End If
        MyPage = e.Graphics
        If PrintDocument1.DefaultPageSettings.Landscape = False Then
            myWidth = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Width - 40)
        Else
            myWidth = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Height - 40)
        End If
        ThisString = "TEST"
        Dim StringSize As New SizeF
        StringSize = MyPage.MeasureString(ThisString, MyFont)
        LineSpace = StringSize.Height + 3

        startY = 50
        Dim MyRtfPrint As New RtfClass
        Rect = New Rectangle(50, startY, 750, 600)
        MyRtfPrint.SetRtfLocation = Rect
        MyRtfPrint.SetRtf = MyRtb
        MyRtfPrint.PrintRtf(e)

        startY = MyRtfPrint.NextPosition + 20
        ThisString = "Test next Y position"
        Rect = New Rectangle(50, startY, 500, 20)
        sf.Alignment = StringAlignment.Near
        sf.LineAlignment = StringAlignment.Near
        MyPage.DrawString(ThisString, MyFont, Brushes.Black, Rect, sf)

        InitDocument()
        e.HasMorePages = False
    End Sub

    Public Sub Startprint()
        StartPage = 0
        InitDocument()
        Dim ppd As New PrintDoc

        ppd.Document = PrintDocument1
        ppd.WindowState = FormWindowState.Maximized
        ppd.ShowDialog()
    End Sub
    Sub InitDocument()
        PrintDocument1.DefaultPageSettings.Landscape = False
        PrintDocument1.OriginAtMargins = True
        PrintDocument1.DefaultPageSettings.Margins = New Drawing.Printing.Margins(0, 0, 0, 0)
        If PrintDocument1.DefaultPageSettings.Landscape = True Then
            MaxHeight = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Width) - 40
            MaxWidth = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Height) - 40
        Else
            MaxWidth = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Width) - 40
            MaxHeight = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Height) - 40
        End If
        pageCounter = 0
        LinesPerPage = MaxHeight / 23
        MyFont = New Font("Calibri", 10)
        startX = 0
        startY = 0
        '   Datatype = 1
       
        TitlePrinted = False
    End Sub
    Sub SetFormat(Value As Object, Formating As String)
        ThisString = ""
        If IsNothing(Value) Then Exit Sub
        Select Case Formating
            Case "N2"
                ThisString = Format(Val(Value), "###,###,##0.00")
            Case "N3"
                ThisString = Format(Val(Value), "###,###,##0.000")
            Case "N6"
                ThisString = Format(Val(Value), "##,##0.000000")
            Case "N8"
                ThisString = Format(Val(Value), "##,##0.00000000")
            Case Else
                ThisString = Value.ToString
        End Select

    End Sub
    Sub SetSf(Align As AlignStyle)
        Try
            Select Case Align
                Case Is = AlignStyle.MiddleRight
                    sf.Alignment = StringAlignment.Far
                    sf.LineAlignment = StringAlignment.Center
                Case Is = AlignStyle.MiddleCenter
                    sf.Alignment = StringAlignment.Center
                    sf.LineAlignment = StringAlignment.Center
                Case Is = AlignStyle.Middleleft
                    sf.Alignment = StringAlignment.Near
                    sf.LineAlignment = StringAlignment.Center
                Case Else
                    sf.Alignment = StringAlignment.Near
                    sf.LineAlignment = StringAlignment.Center
            End Select
            sf.FormatFlags = StringFormatFlags.FitBlackBox
        Catch ex As Exception

        End Try
    End Sub
    Sub SetRecTangle(Width As Integer, Height As Integer, Align As AlignStyle, Border As Boolean)
        Rect = New Rectangle(startX, startY, Width, Height)
        If Border Then MyPage.DrawRectangle(Pens.Black, Rect)
        SetSf(Align)
    End Sub
End Class
